local bVolUp
local VolTick = 0
local LastAudioVol = -25
local LastAudioTick = 0
local LastVol = -25
local LCDOnOff = false
local GlobVolTab = { name = "GloVol",source = 100,weight = 0,offset = 0,switch = 0}
local Simu = false
local VolumeCur = -25

local function CheckAudioVol()
  if math.abs(LastAudioVol - VolumeCur) > 5 then
    --print("CheckAudioVol",LastAudioVol,VolumeCur)
    if getTime() - LastAudioTick > 100 then
      if bVolUp > 0 then
        playFile("/Sounds/de/lauter.wav")
      else
        playFile("/Sounds/de/leiser.wav")
      end
    LastAudioVol = VolumeCur
    LastAudioTick = getTime()  
    end
  end
end
local function SetVolumeInput()
  local count = model.getInputsCount(31)
  for j =1, count, 1 do
    model.deleteInput(31,0)
  end
  GlobVolTab.weight = VolumeCur
  model.insertInput(31, 0, GlobVolTab)
  CheckAudioVol()
end

local function updateVol()
  --scrollwheel in x  98
  local val
  if Simu == true then
    val = getValue("ele")
  else
    val = getValue("jsx")
  end
   
  if val == 1024 or val == -1024 then VolTick = 0 end
  if getTime() - VolTick > 20 then
    if val > 500 then
      if val ~= 1024 then 
        VolTick = getTime()
        VolumeCur = VolumeCur + 1
      else
        VolumeCur = VolumeCur + 2
      end
      bVolUp = 1
      if VolumeCur > 100 then 
        VolumeCur = 100 
        playTone(2250, 40, 20, PLAY_NOW)
      end
      SetVolumeInput()
      return true
    elseif val < -500 then
      if val ~= -1024 then 
        VolTick = getTime()
        VolumeCur = VolumeCur - 1
      else
        VolumeCur = VolumeCur - 2
      end
      bVolUp = -1
      if VolumeCur < -100 then 
        VolumeCur = -100 
        playTone(2250, 40, 20, PLAY_NOW)
      end
      --print("SetVolumeInput",VolumeCur)
      SetVolumeInput()
      return true
    end
  end
end

local jsyPress = false
local LcdToggle = false
local function updateLCD()
  local jsy
  if Simu == true then
    jsy = getValue("ail")
  else
    jsy = getValue("jsy")
  end
  if jsy > 500 then
    if jsyPress == false then
      LCDOnOff = not LCDOnOff  
      LcdToggle = true
      jsyPress = true
    end
  else
    jsyPress = false  
  end
  if LcdToggle == true then
    LcdToggle = false
    if LCDOnOff == true then
        local CuLcdOn = { switch = 125,func = 21}
        model.setCustomFunction(63,CuLcdOn)
        print("Set LED on")
    else
        local CuLcdOff = { switch = 0,func = 0}
        model.setCustomFunction(63,CuLcdOff)
        print("Set LED off")
    end
  end
end

local function VolLcd_init()
  --check simulator
  local ver, radio = getVersion()
  local pos = string.find(radio,"-simu")
  if pos ~= nil then
    print("****simulator detected")
    Simu = true
  end

  --init Volume-Table for Volume-Ctrl
  --print("JZ Volume_init",VolumeCur)
  LastAudioVol = VolumeCur
  LastVol = VolumeCur
  -- setze Custom fct für Volume Control
  local Cust63Fct  = { switch = 125 ,func = 6,value = 32,mode = 0,param = 0 ,active = 1}
  model.setCustomFunction(62,Cust63Fct) 
  local count = model.getInputsCount(31)
  if count == 0 then
    print("create Input for Volume")
    SetVolumeInput()
  else
    local Inp32 = model.getInput(31,0)
    if Inp32 ~= nil then
      VolumeCur = Inp32.weight
      LastAudioVol = VolumeCur
      LastVol = VolumeCur
      print("read Input for Volume",VolumeCur)
    end
  end
  --LCD
  local CusLcd = model.getCustomFunction(63)
  if CusLcd ~= nil and CusLcd.func == 21 then
    LCDOnOff = true
  else
    LCDOnOff = false
  end
end

local function VolLcd_run()
  updateVol()
  updateLCD()
end

return { init=VolLcd_init,run=VolLcd_run }
